
#property indicator_separate_window
#property indicator_levelcolor Black
#property indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 Lime
#property indicator_color3 FireBrick
#property indicator_color4 Red
#property indicator_color5 LawnGreen
#property indicator_color6 HotPink
#property indicator_color7 OrangeRed
#property indicator_width1 4
#property indicator_level1 0.4
#property indicator_width2 4
#property indicator_level2 -0.4
#property indicator_width3 4
#property indicator_level3 0.8
#property indicator_width4 4
#property indicator_level4 -0.8

extern string OtherTimeFrames = "Select below 0=current tf,1,5,15,30,60,240,1440,10080,43200";
extern int select_other_tf_to_show = 0;
extern int H_Pos_MTF = 1;
extern int V_Pos_MTF = 50;
extern int Font_Size_MTF = 12;
extern int Corner_MTF = 3;
extern color Font_Color_MTF = Black;
extern int eintPeriod = 20;
extern double edblHigh1 = 0.4;
extern double edblLow1 = -0.4;
extern int atrPeriod = 100;
extern color Font_Color = White;
extern int H_Pos = 1;
extern int V_Pos = 25;
extern int Corner = 3;
extern int Font_Size = 14;
extern int Font_Size_text = 11;
extern int H_Pos_text = 1;
extern int V_Pos_text = 1;
extern int Text_Corner = 3;
double G_ibuf_168[];
double G_ibuf_172[];
double G_ibuf_176[];
double G_ibuf_180[];
double G_ibuf_184[];
double G_ibuf_188[];
double G_ibuf_192[];
double Gd_200;
bool G_bool_208;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorBuffers(7);
   IndicatorDigits(5);
   IndicatorShortName("LRFF-10.2 TmaSlope v.8");
   G_bool_208 = MarketInfo(Symbol(), MODE_MARGINCALCMODE) == 0.0 && MarketInfo(Symbol(), MODE_PROFITCALCMODE) == 0.0 && Digits % 2 == 1;
   Gd_200 = f0_2();
   SetIndexBuffer(0, G_ibuf_168);
   SetIndexLabel(0, NULL);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, G_ibuf_172);
   SetIndexLabel(1, NULL);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2, G_ibuf_176);
   SetIndexLabel(2, NULL);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3, G_ibuf_180);
   SetIndexLabel(3, NULL);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4, G_ibuf_184);
   SetIndexLabel(4, NULL);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexBuffer(5, G_ibuf_188);
   SetIndexLabel(5, NULL);
   SetIndexStyle(5, DRAW_HISTOGRAM);
   SetIndexBuffer(6, G_ibuf_192);
   SetIndexLabel(6, "TMA Slope");
   SetIndexStyle(6, DRAW_NONE);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double Ld_8;
   double Ld_16;
   double Ld_24;
   double Ld_32;
   double Ld_40;
   double Ld_48;
   string dbl2str_60;
   string Ls_unused_68;
   string Ls_unused_80;
   double Ld_88;
   string dbl2str_96;
   int Li_0 = IndicatorCounted();
   if (Li_0 < 0) return (-1);
   if (Li_0 > 0) Li_0--;
   int Li_4 = MathMin(Bars - 1, Bars - Li_0 + eintPeriod);
   for (int Li_56 = Li_4; Li_56 >= 0; Li_56--) {
      Ld_40 = iATR(NULL, 0, atrPeriod, Li_56 + 10) / 10.0;
      Ld_48 = iATR(NULL, select_other_tf_to_show, atrPeriod, Li_56 + 10) / 10.0;
      if (Ld_40 != 0.0) {
         if (Ld_48 != 0.0) {
            Ld_8 = f0_0(Li_56);
            Ld_16 = f0_0(Li_56 + 1);
            G_ibuf_192[Li_56] = (Ld_8 - Ld_16) / Ld_40;
            G_ibuf_168[Li_56] = 0.0;
            G_ibuf_176[Li_56] = 0.0;
            G_ibuf_184[Li_56] = 0.0;
            G_ibuf_172[Li_56] = 0.0;
            G_ibuf_180[Li_56] = 0.0;
            G_ibuf_188[Li_56] = 0.0;
            if (G_ibuf_192[Li_56] > edblHigh1) {
               if (G_ibuf_192[Li_56] < G_ibuf_192[Li_56 + 1]) G_ibuf_168[Li_56] = G_ibuf_192[Li_56];
               else G_ibuf_172[Li_56] = G_ibuf_192[Li_56];
            } else {
               if (G_ibuf_192[Li_56] < edblLow1) {
                  if (G_ibuf_192[Li_56] < G_ibuf_192[Li_56 + 1]) G_ibuf_180[Li_56] = G_ibuf_192[Li_56];
                  else G_ibuf_176[Li_56] = G_ibuf_192[Li_56];
               } else {
                  if (G_ibuf_192[Li_56] < G_ibuf_192[Li_56 + 1]) G_ibuf_188[Li_56] = G_ibuf_192[Li_56];
                  else G_ibuf_184[Li_56] = G_ibuf_192[Li_56];
               }
            }
            dbl2str_60 = DoubleToStr(G_ibuf_192[Li_56], 2);
            Ls_unused_68 = "InfoBar1";
            switch (select_other_tf_to_show) {
            case PERIOD_M1:
               Ls_unused_80 = "M1";
               break;
            case PERIOD_M5:
               Ls_unused_80 = "M5";
               break;
            case PERIOD_M15:
               Ls_unused_80 = "M15";
               break;
            case PERIOD_M30:
               Ls_unused_80 = "M30";
               break;
            case PERIOD_H1:
               Ls_unused_80 = "H1";
               break;
            case PERIOD_H4:
               Ls_unused_80 = "H4";
               break;
            case PERIOD_D1:
               Ls_unused_80 = "D1";
               break;
            case PERIOD_W1:
               Ls_unused_80 = "W1";
               break;
            case PERIOD_MN1:
               Ls_unused_80 = "MN1";
               break;
            default:
               Ls_unused_80 = "Current";
            }
            Ld_24 = f0_1(0, select_other_tf_to_show);
            Ld_32 = f0_1(1, select_other_tf_to_show);
            Ld_88 = (Ld_24 - Ld_32) / Ld_48;
            if (Ld_88 >= 0.5) Font_Color_MTF = Black;
            else {
               if (Ld_88 <= -0.5) Font_Color_MTF = Red;
               else Font_Color_MTF = DarkGreen;
            }
            dbl2str_96 = DoubleToStr(Ld_88, 2);
         }
      }
   }
   return (0);
}

// F6282DF0E2FDAB64B11BF107AFF51981
double f0_2() {
   double Ld_ret_0 = MarketInfo(Symbol(), MODE_TICKSIZE);
   if (G_bool_208) Ld_ret_0 = 10.0 * Ld_ret_0;
   return (Ld_ret_0);
}

// 6AEC963F71D252D6A7B1669E23A649CF
double f0_0(int Ai_0) {
   double Ld_4 = (eintPeriod + 1) * Close[Ai_0];
   double Ld_12 = eintPeriod + 1;
   int Li_20 = 1;
   for (int Li_24 = eintPeriod; Li_20 <= eintPeriod; Li_24--) {
      Ld_4 += Li_24 * (Close[Ai_0 + Li_20]);
      Ld_12 += Li_24;
      if (Li_20 <= Ai_0) {
         Ld_4 += Li_24 * (Close[Ai_0 - Li_20]);
         Ld_12 += Li_24;
      }
      Li_20++;
   }
   return (Ld_4 / Ld_12);
}

// C6E61D02A9D0BC1CE1359498C1E0BCEF
double f0_1(int Ai_0, int A_timeframe_4) {
   double Ld_8 = (eintPeriod + 1) * iClose(Symbol(), A_timeframe_4, Ai_0);
   double Ld_16 = eintPeriod + 1;
   int Li_24 = 1;
   for (int Li_28 = eintPeriod; Li_24 <= eintPeriod; Li_28--) {
      Ld_8 += Li_28 * iClose(Symbol(), A_timeframe_4, Ai_0 + Li_24);
      Ld_16 += Li_28;
      if (Li_24 <= Ai_0) {
         Ld_8 += Li_28 * iClose(Symbol(), A_timeframe_4, Ai_0 - Li_24);
         Ld_16 += Li_28;
      }
      Li_24++;
   }
   return (Ld_8 / Ld_16);
}